' This is file libzib-0.9.3_TJF.bi.
'
' FreeBasic-Header file for libzip, translated with help of h_2_bi.bas by
' Thomas.Freiherr@gmx.net.
'
' Licence:
'
' This library binding is free software; you can redistribute it
' and/or modify it under the terms of the GNU Lesser General Public
' License as published by the Free Software Foundation; either
' version 2 of the License, or (at your option) ANY later version.
'
' This library is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
' Lesser General Public License for more details, refer to:
' http://www.gnu.org/licenses/lgpl.html

#IF (__FB_VER_MAJOR__ = 0) AND (__FB_VER_MINOR__ < 20)
  #ERROR "fbc version >= 0.20 expected (update your compiler)"
#ENDIF

#IFDEF __FB_WIN32__
 #PRAGMA push(msbitfields)
#ENDIF

#INCLIB "zip"
#LANG "fb"
EXTERN "C"

' 00file: libzip-8b62bb77cd45/lib/zipint.h

#IFNDEF _HAD_ZIPINT_H
#DEFINE _HAD_ZIPINT_H
#INCLUDE ONCE "zlib.bi" '__BI_REPS__(){};

#IFDEF _WIN32
#DEFINE ZIP_EXTERN __declspec(dllexport)
#ENDIF ' _WIN32

' 01file: libzip-8b62bb77cd45/lib/zip.h

#IFNDEF _HAD_ZIP_H
#DEFINE _HAD_ZIP_H

' 02file: zipconf.h

#IFNDEF _HAD_ZIPCONF_H
#DEFINE _HAD_ZIPCONF_H
#INCLUDE ONCE "crt/sys/types.bi" '__BI_REPS__(){};

TYPE AS BYTE zip_int8_t
TYPE AS UBYTE zip_uint8_t
TYPE AS SHORT zip_int16_t
TYPE AS USHORT zip_uint16_t
TYPE AS INTEGER zip_int32_t
TYPE AS UINTEGER zip_uint32_t
TYPE AS LONGINT zip_int64_t
TYPE AS ULONGINT zip_uint64_t

#DEFINE ZIP_INT8_MIN  -&h80
#DEFINE ZIP_INT8_MAX   &h7f
#DEFINE ZIP_UINT8_MAX  &hff
#DEFINE ZIP_INT16_MIN -&h8000
#DEFINE ZIP_INT16_MAX  &h7fff
#DEFINE ZIP_UINT16_MAX   &hffff
#DEFINE ZIP_INT32_MIN -&h80000000L
#DEFINE ZIP_INT32_MAX  &h7fffffffL
#DEFINE ZIP_UINT32_MAX   &hffffffffLU
#DEFINE ZIP_INT64_MIN -&h8000000000000000LL
#DEFINE ZIP_INT64_MAX  &h7fffffffffffffffLL
#DEFINE ZIP_UINT64_MAX   &hffffffffffffffffULL
#ENDIF ' _HAD_ZIPCONF_H

' 01back from zipconf.h => libzip-8b62bb77cd45/lib/zip.h

#INCLUDE ONCE "crt/sys/types.bi" '__BI_REPS__(){};
#INCLUDE ONCE "crt/stdio.bi" '__BI_REPS__(){};
#INCLUDE ONCE "crt/time.bi" '__BI_REPS__(){};
#DEFINE ZIP_CREATE           1
#DEFINE ZIP_EXCL             2
#DEFINE ZIP_CHECKCONS        4
#DEFINE ZIP_FL_NOCASE   1
#DEFINE ZIP_FL_NODIR    2
#DEFINE ZIP_FL_COMPRESSED 4
#DEFINE ZIP_FL_UNCHANGED  8
#DEFINE ZIP_FL_RECOMPRESS      16
#DEFINE ZIP_FL_ENCRYPTED       32
#DEFINE ZIP_AFL_TORRENT   1
#DEFINE ZIP_AFL_RDONLY    2
#DEFINE ZIP_CODEC_ENCODE  1
#DEFINE ZIP_ER_OK             0
#DEFINE ZIP_ER_MULTIDISK      1
#DEFINE ZIP_ER_RENAME         2
#DEFINE ZIP_ER_CLOSE          3
#DEFINE ZIP_ER_SEEK           4
#DEFINE ZIP_ER_READ           5
#DEFINE ZIP_ER_WRITE          6
#DEFINE ZIP_ER_CRC            7
#DEFINE ZIP_ER_ZIPCLOSED      8
#DEFINE ZIP_ER_NOENT          9
#DEFINE ZIP_ER_EXISTS        10
#DEFINE ZIP_ER_OPEN          11
#DEFINE ZIP_ER_TMPOPEN       12
#DEFINE ZIP_ER_ZLIB          13
#DEFINE ZIP_ER_MEMORY        14
#DEFINE ZIP_ER_CHANGED       15
#DEFINE ZIP_ER_COMPNOTSUPP   16
#DEFINE ZIP_ER_EOF           17
#DEFINE ZIP_ER_INVAL         18
#DEFINE ZIP_ER_NOZIP         19
#DEFINE ZIP_ER_INTERNAL      20
#DEFINE ZIP_ER_INCONS        21
#DEFINE ZIP_ER_REMOVE        22
#DEFINE ZIP_ER_DELETED       23
#DEFINE ZIP_ER_ENCRNOTSUPP   24
#DEFINE ZIP_ER_RDONLY        25
#DEFINE ZIP_ER_NOPASSWD      26
#DEFINE ZIP_ER_WRONGPASSWD   27
#DEFINE ZIP_ET_NONE       0
#DEFINE ZIP_ET_SYS        1
#DEFINE ZIP_ET_ZLIB       2
#DEFINE ZIP_CM_DEFAULT        -1
#DEFINE ZIP_CM_STORE         0
#DEFINE ZIP_CM_SHRINK        1
#DEFINE ZIP_CM_REDUCE_1        2
#DEFINE ZIP_CM_REDUCE_2        3
#DEFINE ZIP_CM_REDUCE_3        4
#DEFINE ZIP_CM_REDUCE_4        5
#DEFINE ZIP_CM_IMPLODE         6
#DEFINE ZIP_CM_DEFLATE         8
#DEFINE ZIP_CM_DEFLATE64       9
#DEFINE ZIP_CM_PKWARE_IMPLODE 10
#DEFINE ZIP_CM_BZIP2          12
#DEFINE ZIP_CM_LZMA       14
#DEFINE ZIP_CM_TERSE        18
#DEFINE ZIP_CM_LZ77           19
#DEFINE ZIP_CM_WAVPACK        97
#DEFINE ZIP_CM_PPMD       98
#DEFINE ZIP_EM_NONE        0
#DEFINE ZIP_EM_TRAD_PKWARE     1

#IF 0
#DEFINE ZIP_EM_DES        &h6601
#DEFINE ZIP_EM_RC2_OLD    &h6602
#DEFINE ZIP_EM_3DES_168   &h6603
#DEFINE ZIP_EM_3DES_112   &h6609
#DEFINE ZIP_EM_AES_128    &h660e
#DEFINE ZIP_EM_AES_192    &h660f
#DEFINE ZIP_EM_AES_256    &h6610
#DEFINE ZIP_EM_RC2        &h6702
#DEFINE ZIP_EM_RC4        &h6801
#ENDIF

#DEFINE ZIP_EM_UNKNOWN    &hffff

ENUM zip_source_cmd
  ZIP_SOURCE_OPEN_TJF
  ZIP_SOURCE_READ_TJF
  ZIP_SOURCE_CLOSE_TJF
  ZIP_SOURCE_STAT_TJF
  ZIP_SOURCE_ERROR_TJF
  ZIP_SOURCE_FREE_TJF
END ENUM

#DEFINE ZIP_SOURCE_ERR_LOWER  -2
#DEFINE ZIP_STAT_NAME     &h1
#DEFINE ZIP_STAT_INDEX_TJF      &h2
#DEFINE ZIP_STAT_SIZE     &h4
#DEFINE ZIP_STAT_COMP_SIZE    &h8
#DEFINE ZIP_STAT_MTIME      &h10
#DEFINE ZIP_STAT_CRC      &h20
#DEFINE ZIP_STAT_COMP_METHOD    &h40
#DEFINE ZIP_STAT_ENCRYPTION_METHOD  &h80
#DEFINE ZIP_STAT_FLAGS      &h100

TYPE zip_stat
  AS zip_uint64_t valid
  AS CONST ZSTRING PTR name
  AS zip_uint64_t index
  AS zip_uint64_t size
  AS zip_uint64_t comp_size
  AS time_t mtime
  AS zip_uint32_t crc
  AS zip_uint16_t comp_method
  AS zip_uint16_t encryption_method
  AS zip_uint32_t flags
END TYPE

TYPE zip AS zip_TJF
TYPE zip_file AS zip_file_TJF
TYPE zip_source AS zip_source_TJF
TYPE zip_source_callback AS FUNCTION(AS ANY PTR, AS ANY PTR, AS zip_uint64_t, AS zip_source_cmd) AS zip_int64_t
TYPE zip_source_layered_callback AS FUNCTION(AS zip_source PTR, AS ANY PTR, AS ANY PTR, AS zip_uint64_t, AS zip_source_cmd) AS zip_int64_t
TYPE zip_compression_implementation AS FUNCTION(AS zip PTR, AS zip_source PTR, AS zip_uint16_t, AS INTEGER) AS zip_source PTR
TYPE zip_encryption_implementation AS FUNCTION(AS zip PTR, AS zip_source PTR, AS zip_uint16_t, AS INTEGER, AS CONST ZSTRING PTR) AS zip_source PTR

DECLARE FUNCTION zip_add(AS zip PTR, AS CONST ZSTRING PTR, AS zip_source PTR) AS zip_int64_t
DECLARE FUNCTION zip_add_dir(AS zip PTR, AS CONST ZSTRING PTR) AS zip_int64_t
DECLARE FUNCTION zip_close(AS zip PTR) AS INTEGER
DECLARE FUNCTION zip_delete(AS zip PTR, AS zip_uint64_t) AS INTEGER
DECLARE SUB zip_error_clear(AS zip PTR)
DECLARE SUB zip_error_get(AS zip PTR, AS INTEGER PTR, AS INTEGER PTR)
DECLARE FUNCTION zip_error_get_sys_type(AS INTEGER) AS INTEGER
DECLARE FUNCTION zip_error_to_str(AS ZSTRING PTR, AS zip_uint64_t, AS INTEGER, AS INTEGER) AS INTEGER
DECLARE FUNCTION zip_fclose(AS zip_file PTR) AS INTEGER
DECLARE FUNCTION zip_fdopen(AS INTEGER, AS INTEGER, AS INTEGER PTR) AS zip PTR
DECLARE SUB zip_file_error_clear(AS zip_file PTR)
DECLARE SUB zip_file_error_get(AS zip_file PTR, AS INTEGER PTR, AS INTEGER PTR)
DECLARE FUNCTION zip_file_strerror(AS zip_file PTR) AS CONST ZSTRING PTR
DECLARE FUNCTION zip_fopen(AS zip PTR, AS CONST ZSTRING PTR, AS INTEGER) AS zip_file PTR
DECLARE FUNCTION zip_fopen_encrypted(AS zip PTR, AS CONST ZSTRING PTR, AS INTEGER, AS CONST ZSTRING PTR) AS zip_file PTR
DECLARE FUNCTION zip_fopen_index(AS zip PTR, AS zip_uint64_t, AS INTEGER) AS zip_file PTR
DECLARE FUNCTION zip_fopen_index_encrypted(AS zip PTR, AS zip_uint64_t, AS INTEGER, AS CONST ZSTRING PTR) AS zip_file PTR
DECLARE FUNCTION zip_fread(AS zip_file PTR, AS ANY PTR, AS zip_uint64_t) AS zip_int64_t
DECLARE FUNCTION zip_get_archive_comment(AS zip PTR, AS INTEGER PTR, AS INTEGER) AS CONST ZSTRING PTR
DECLARE FUNCTION zip_get_archive_flag(AS zip PTR, AS INTEGER, AS INTEGER) AS INTEGER
DECLARE FUNCTION zip_get_compression_implementation(AS zip_uint16_t) AS zip_compression_implementation
DECLARE FUNCTION zip_get_encryption_implementation(AS zip_uint16_t) AS zip_encryption_implementation
DECLARE FUNCTION zip_get_file_comment(AS zip PTR, AS zip_uint64_t, AS INTEGER PTR, AS INTEGER) AS CONST ZSTRING PTR
DECLARE FUNCTION zip_get_name(AS zip PTR, AS zip_uint64_t, AS INTEGER) AS CONST ZSTRING PTR
DECLARE FUNCTION zip_get_num_files(AS zip PTR) AS INTEGER
DECLARE FUNCTION zip_name_locate(AS zip PTR, AS CONST ZSTRING PTR, AS INTEGER) AS INTEGER
DECLARE FUNCTION zip_open(AS CONST ZSTRING PTR, AS INTEGER, AS INTEGER PTR) AS zip PTR
DECLARE FUNCTION zip_rename(AS zip PTR, AS zip_uint64_t, AS CONST ZSTRING PTR) AS INTEGER
DECLARE FUNCTION zip_replace(AS zip PTR, AS zip_uint64_t, AS zip_source PTR) AS INTEGER
DECLARE FUNCTION zip_set_archive_comment(AS zip PTR, AS CONST ZSTRING PTR, AS INTEGER) AS INTEGER
DECLARE FUNCTION zip_set_archive_flag(AS zip PTR, AS INTEGER, AS INTEGER) AS INTEGER
DECLARE FUNCTION zip_set_default_password(AS zip PTR, AS CONST ZSTRING PTR) AS INTEGER
DECLARE FUNCTION zip_set_file_comment(AS zip PTR, AS zip_uint64_t, AS CONST ZSTRING PTR, AS INTEGER) AS INTEGER
DECLARE FUNCTION zip_source_buffer(AS zip PTR, AS CONST ANY PTR, AS zip_uint64_t, AS INTEGER) AS zip_source PTR
DECLARE SUB zip_source_close(AS zip_source PTR)
DECLARE FUNCTION zip_source_crc(AS zip PTR, AS zip_source PTR, AS INTEGER) AS zip_source PTR
DECLARE FUNCTION zip_source_deflate(AS zip PTR, AS zip_source PTR, AS zip_uint16_t, AS INTEGER) AS zip_source PTR
DECLARE SUB zip_source_error(AS zip_source PTR, AS INTEGER PTR, AS INTEGER PTR)
DECLARE FUNCTION zip_source_file(AS zip PTR, AS CONST ZSTRING PTR, AS zip_uint64_t, AS zip_int64_t) AS zip_source PTR
DECLARE FUNCTION zip_source_filep(AS zip PTR, AS FILE PTR, AS zip_uint64_t, AS zip_int64_t) AS zip_source PTR
DECLARE SUB zip_source_free(AS zip_source PTR)
DECLARE FUNCTION zip_source_function(AS zip PTR, AS zip_source_callback, AS ANY PTR) AS zip_source PTR
DECLARE FUNCTION zip_source_layered(AS zip PTR, AS zip_source PTR, AS zip_source_layered_callback, AS ANY PTR) AS zip_source PTR
DECLARE FUNCTION zip_source_open(AS zip_source PTR) AS INTEGER
DECLARE FUNCTION zip_source_pkware(AS zip PTR, AS zip_source PTR, AS zip_uint16_t, AS INTEGER, AS CONST ZSTRING PTR) AS zip_source PTR
DECLARE FUNCTION zip_source_pop(AS zip_source PTR) AS zip_source PTR
DECLARE FUNCTION zip_source_read(AS zip_source PTR, AS ANY PTR, AS zip_uint64_t) AS zip_int64_t
DECLARE FUNCTION zip_source_stat(AS zip_source PTR, AS zip_stat PTR) AS INTEGER
DECLARE FUNCTION zip_source_zip(AS zip PTR, AS zip PTR, AS zip_uint64_t, AS INTEGER, AS zip_uint64_t, AS zip_int64_t) AS zip_source PTR
DECLARE FUNCTION zip_stat(AS zip PTR, AS CONST ZSTRING PTR, AS INTEGER, AS zip_stat PTR) AS INTEGER
DECLARE FUNCTION zip_stat_index(AS zip PTR, AS zip_uint64_t, AS INTEGER, AS zip_stat PTR) AS INTEGER
DECLARE SUB zip_stat_init(AS zip_stat PTR)
DECLARE FUNCTION zip_strerror(AS zip PTR) AS CONST ZSTRING PTR
DECLARE FUNCTION zip_unchange(AS zip PTR, AS zip_uint64_t) AS INTEGER
DECLARE FUNCTION zip_unchange_all(AS zip PTR) AS INTEGER
DECLARE FUNCTION zip_unchange_archive(AS zip PTR) AS INTEGER

#IFDEF __cplusplus
#ENDIF ' __cplusplus
#ENDIF ' _HAD_ZIP_H

' 00back from libzip-8b62bb77cd45/lib/zip.h => libzip-8b62bb77cd45/lib/zipint.h
' 01file: config.h

#IFNDEF HAD_CONFIG_H
#DEFINE HAD_CONFIG_H
#DEFINE PACKAGE !"libzip"
#DEFINE VERSION !"0.9.3"
#ENDIF ' HAD_CONFIG_H

' 00back from config.h => libzip-8b62bb77cd45/lib/zipint.h

#IFNDEF HAVE_FSEEKO
#DEFINE fseeko(s, o, w) (fseek((s), CAST(LONGINT, (o)), (w)))
#ENDIF ' HAVE_FSEEKO

#IFNDEF HAVE_FTELLO
#DEFINE ftello(s) (CAST(INTEGER, ftell((s))))
#ENDIF ' HAVE_FTELLO

#IFNDEF HAVE_MKSTEMP

DECLARE FUNCTION _zip_mkstemp(AS ZSTRING PTR) AS INTEGER

#DEFINE mkstemp _zip_mkstemp
#ENDIF ' HAVE_MKSTEMP

#IFDEF HAVE_MOVEFILEEXA
#INCLUDE ONCE "windows.bi" '__BI_REPS__(){};
#DEFINE _zip_rename(s, t)           _
 (0 = MoveFileExA((s), (t), _
       MOVEFILE_COPY_ALLOWEDOR MOVEFILE_REPLACE_EXISTING))
#ELSE ' HAVE_MOVEFILEEXA
#DEFINE _zip_rename rename
#ENDIF ' HAVE_MOVEFILEEXA

#IF DEFINED(HAVE_OPEN)
#IF DEFINED(HAVE__OPEN)
#DEFINE open_TJF(a, b, c) _open((a), (b))
#ENDIF
#ENDIF

#IF DEFINED(HAVE_SNPRINTF)
#IF DEFINED(HAVE__SNPRINTF)
#DEFINE snprintf  _snprintf
#ENDIF
#ENDIF

#IF DEFINED(HAVE_STRCASECMP)
#IF DEFINED(HAVE__STRCMPI)
#DEFINE strcasecmp  _strcmpi
#ENDIF
#ENDIF

#IF DEFINED(HAVE_STRDUP)
#IF DEFINED(HAVE__STRDUP)
#DEFINE strdup    _strdup
#ENDIF
#ENDIF

#DEFINE CENTRAL_MAGIC !"PK\1\2"
#DEFINE LOCAL_MAGIC   !"PK\3\4"
#DEFINE EOCD_MAGIC    !"PK\5\6"
#DEFINE DATADES_MAGIC !"PK\7\8"
#DEFINE TORRENT_SIG !"TORRENTZIPPED-"
#DEFINE TORRENT_SIG_LEN 14
#DEFINE TORRENT_CRC_LEN 8
#DEFINE TORRENT_MEM_LEVEL 8
#DEFINE CDENTRYSIZE         46u
#DEFINE LENTRYSIZE          30
#DEFINE MAXCOMLEN        65536
#DEFINE EOCDLEN             22
#DEFINE CDBUFSIZE       (MAXCOMLEN+EOCDLEN)
#DEFINE BUFSIZE   8192

ENUM zip_state
  ZIP_ST_UNCHANGED
  ZIP_ST_DELETED
  ZIP_ST_REPLACED
  ZIP_ST_ADDED
  ZIP_ST_RENAMED
END ENUM

ENUM zip_les
  ZIP_LES_NONE
  ZIP_LES_UPPER
  ZIP_LES_LOWER
  ZIP_LES_INVAL
END ENUM

#DEFINE ZIP_GPBF_ENCRYPTED    &h1
#DEFINE ZIP_GPBF_DATA_DESCRIPTOR  &h8
#DEFINE ZIP_GPBF_STRONG_ENCRYPTION  &h40

TYPE zip_error
  AS INTEGER zip_err
  AS INTEGER sys_err
  AS ZSTRING PTR str
END TYPE

TYPE zip_file_TJF
  AS zip PTR za
  AS zip_error error
  AS INTEGER eof
  AS zip_source PTR src
END TYPE

TYPE zip_dirent
  AS USHORT version_madeby
  AS USHORT version_needed
  AS USHORT bitflags
  AS USHORT comp_method
  AS time_t last_mod
  AS UINTEGER crc
  AS UINTEGER comp_size
  AS UINTEGER uncomp_size
  AS ZSTRING PTR filename
  AS USHORT filename_len
  AS ZSTRING PTR extrafield
  AS USHORT extrafield_len
  AS ZSTRING PTR comment
  AS USHORT comment_len
  AS USHORT disk_number
  AS USHORT int_attrib
  AS UINTEGER ext_attrib
  AS UINTEGER offset
END TYPE

TYPE zip_cdir
  AS zip_dirent PTR entry
  AS INTEGER nentry
  AS UINTEGER size
  AS UINTEGER offset
  AS ZSTRING PTR comment
  AS USHORT comment_len
END TYPE

UNION zip_source_cb
  AS zip_source_callback f
  AS zip_source_layered_callback l
END UNION

TYPE zip_source_TJF
  AS zip_source PTR src
  AS zip_source_cb cb
  AS ANY PTR ud
  AS zip_les error_source
  AS INTEGER is_open
END TYPE

TYPE zip_entry
  AS zip_state state
  AS zip_source PTR source
  AS ZSTRING PTR ch_filename
  AS ZSTRING PTR ch_comment
  AS INTEGER ch_comment_len
END TYPE

TYPE zip_TJF
  AS ZSTRING PTR zn
  AS FILE PTR zp
  AS zip_error error
  AS UINTEGER flags
  AS UINTEGER ch_flags
  AS ZSTRING PTR default_password
  AS zip_cdir PTR cdir
  AS ZSTRING PTR ch_comment
  AS INTEGER ch_comment_len
  AS zip_uint64_t nentry
  AS zip_uint64_t nentry_alloc
  AS zip_entry PTR entry
  AS INTEGER nfile
  AS INTEGER nfile_alloc
  AS zip_file PTR PTR file
END TYPE

EXTERN AS CONST ZSTRING CONST PTR PTR _zip_err_str
EXTERN AS CONST INTEGER _zip_nerr_str
EXTERN AS CONST INTEGER PTR _zip_err_type

#DEFINE ZIP_ENTRY_DATA_CHANGED(x) _
   ((x)->state = ZIP_ST_REPLACED _
    ORELSE (x)->state = ZIP_ST_ADDED)
#DEFINE ZIP_IS_RDONLY(za) ((za)-ch_flags AND ZIP_AFL_RDONLY)

DECLARE FUNCTION _zip_cdir_compute_crc(AS zip PTR, AS ULONG PTR) AS INTEGER
DECLARE SUB _zip_cdir_free(AS zip_cdir PTR)
DECLARE FUNCTION _zip_cdir_grow(AS zip_cdir PTR, AS INTEGER, AS zip_error PTR) AS INTEGER

TYPE _zip_cdir_new AS FUNCTION(AS INTEGER, AS zip_error PTR) AS zip_cdir PTR

DECLARE FUNCTION _zip_cdir_write(AS zip_cdir PTR, AS FILE PTR, AS zip_error PTR) AS INTEGER
DECLARE SUB _zip_dirent_finalize(AS zip_dirent PTR)
DECLARE SUB _zip_dirent_init(AS zip_dirent PTR)
DECLARE FUNCTION _zip_dirent_read(AS zip_dirent PTR, AS FILE PTR, AS UBYTE PTR PTR, AS zip_uint32_t PTR, AS INTEGER, AS zip_error PTR) AS INTEGER
DECLARE SUB _zip_dirent_torrent_normalize(AS zip_dirent PTR)
DECLARE FUNCTION _zip_dirent_write(AS zip_dirent PTR, AS FILE PTR, AS INTEGER, AS zip_error PTR) AS INTEGER
DECLARE SUB _zip_entry_free(AS zip_entry PTR)
DECLARE SUB _zip_entry_init(AS zip PTR, AS INTEGER)

TYPE _zip_entry_new AS FUNCTION(AS zip PTR) AS zip_entry PTR

DECLARE SUB _zip_error_clear(AS zip_error PTR)
DECLARE SUB _zip_error_copy(AS zip_error PTR, AS zip_error PTR)
DECLARE SUB _zip_error_fini(AS zip_error PTR)
DECLARE SUB _zip_error_get(AS zip_error PTR, AS INTEGER PTR, AS INTEGER PTR)
DECLARE SUB _zip_error_init(AS zip_error PTR)
DECLARE SUB _zip_error_set(AS zip_error PTR, AS INTEGER, AS INTEGER)
DECLARE SUB _zip_error_set_from_source(AS zip_error PTR, AS zip_source PTR)
DECLARE FUNCTION _zip_error_strerror(AS zip_error PTR) AS CONST ZSTRING PTR
DECLARE FUNCTION _zip_file_fillbuf(AS ANY PTR, AS size_t, AS zip_file PTR) AS INTEGER
DECLARE FUNCTION _zip_file_get_offset(AS zip PTR, AS INTEGER) AS UINTEGER
DECLARE FUNCTION _zip_filerange_crc(AS FILE PTR, AS off_t, AS off_t, AS ULONG PTR, AS zip_error PTR) AS INTEGER

TYPE _zip_open AS FUNCTION(AS CONST ZSTRING PTR, AS FILE PTR, AS INTEGER, AS INTEGER, AS INTEGER PTR) AS zip PTR
TYPE _zip_source_file_or_p AS FUNCTION(AS zip PTR, AS CONST ZSTRING PTR, AS FILE PTR, AS zip_uint64_t, AS zip_int64_t, AS INTEGER, AS CONST zip_stat PTR) AS zip_source PTR
TYPE _zip_source_new AS FUNCTION(AS zip PTR) AS zip_source PTR

DECLARE FUNCTION _zip_changed(AS zip PTR, AS INTEGER PTR) AS INTEGER
DECLARE SUB _zip_free(AS zip PTR)
DECLARE FUNCTION _zip_get_name(AS zip PTR, AS zip_uint64_t, AS INTEGER, AS zip_error PTR) AS CONST ZSTRING PTR
DECLARE FUNCTION _zip_local_header_read(AS zip PTR, AS INTEGER) AS INTEGER
DECLARE FUNCTION _zip_memdup(AS CONST ANY PTR, AS size_t, AS zip_error PTR) AS ANY PTR
DECLARE FUNCTION _zip_name_locate(AS zip PTR, AS CONST ZSTRING PTR, AS INTEGER, AS zip_error PTR) AS INTEGER

TYPE _zip_new AS FUNCTION(AS zip_error PTR) AS zip PTR

DECLARE FUNCTION _zip_read2(AS UBYTE PTR PTR) AS USHORT
DECLARE FUNCTION _zip_read4(AS UBYTE PTR PTR) AS UINTEGER
DECLARE FUNCTION _zip_replace(AS zip PTR, AS zip_uint64_t, AS CONST ZSTRING PTR, AS zip_source PTR) AS zip_int64_t
DECLARE FUNCTION _zip_set_name(AS zip PTR, AS zip_uint64_t, AS CONST ZSTRING PTR) AS INTEGER
DECLARE SUB _zip_u2d_time(AS time_t, AS USHORT PTR, AS USHORT PTR)
DECLARE FUNCTION _zip_unchange(AS zip PTR, AS zip_uint64_t, AS INTEGER) AS INTEGER
DECLARE SUB _zip_unchange_data(AS zip_entry PTR)

#ENDIF ' _HAD_ZIPINT_H

END EXTERN

#IFDEF __FB_WIN32__
 #PRAGMA pop(msbitfields)
#ENDIF

' Translated at 10-08-19 11:23:03, by h_2_bi (v 0.1.9.1,
' released under GPLv3 by Thomas.Freiherr@gmx.net)

'   Protocol: libzip-0.9.3_TJF.bi
' Parameters: -f
'                                  Bytes translated: 18019
'                                      Maximum deep: 3
'                                        Files done: 4
'                                SUB/FUNCTION names: 10
'                                       __BI_REPS__: 3
'2: sys/types.h>crt/sys/types.bi
'1: zlib.h>zlib.bi
'1: windows.h>windows.bi
'                                        __MACROS__: 1
'56: ZIP_EXTERN
'                                    __BASIC_REPS__: 6
'1: ZIP_STAT_INDEX&_TJF
'1: ZIP_SOURCE_OPEN&_TJF
'1: ZIP_SOURCE_READ&_TJF
'1: ZIP_SOURCE_CLOSE&_TJF
'1: ZIP_SOURCE_STAT&_TJF
'1: ZIP_SOURCE_ERROR&_TJF
'1: ZIP_SOURCE_FREE&_TJF
